<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Generic Lists</TITLE>
<link href="suif1_93.html" rel=Next>
<link href="suif1_91.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_91.html">previous</A>, <A HREF="suif1_93.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC92" HREF="suif1_toc.html#TOC92">Generic Lists</A></H2>
<P>
<A NAME="IDX654"></A>
<A NAME="IDX655"></A>
<A NAME="IDX656"></A>

</P>
<P>
<A NAME="IDX657"></A>
While linked lists are not very efficient data structures, they are
flexible and work well for a research compiler like SUIF.  Various kinds
of lists are used throughout the SUIF library and most SUIF programs.
Almost all of these lists are derived from the <CODE>glist</CODE> base class.
The files <TT>`glist.h'</TT> and <TT>`glist.cc'</TT> contain the declaration and
implementation of this class.

</P>
<P>
<A NAME="IDX658"></A>
The individual elements of these lists are derived from the
<CODE>glist_e</CODE> class.  The base class only contains a pointer to the
next element.  To make a useful list, a derived class must add data
fields to the list elements.  For doubly-linked lists, the list elements
are further extended to include backwards pointers (see section <A HREF="suif1_95.html#SEC95">Doubly-Linked Lists</A>).

</P>
<P>
The <CODE>glist</CODE> class includes pointers to the head and tail elements.
This makes it possible to efficiently add elements at either end of the
list.  A variety of methods are provided to insert and remove individual
elements, as well as to combine entire lists in different ways.  All of
these operations are straightforward and are clearly documented in the
code.

</P>
<P>
<A NAME="IDX659"></A>
<A NAME="IDX660"></A>
The SUIF library also provides iterators for lists.  This allows you to
write code at a higher level of abstraction.  Instead of rewriting the
same code everywhere that your program traverses lists, you can just use
the built-in iterators.  The base iterator class is <CODE>glist_iter</CODE>.
An iterator is initialized with a pointer to a particular list.  It then
returns successive elements from the list (via the <CODE>step</CODE> method)
until the <CODE>is_empty</CODE> method returns <CODE>TRUE</CODE>.  Other methods are
available to access the current and next list elements without advancing
the iterator.

</P>
<P>
<A NAME="IDX661"></A>
To make a list with a particular type of elements, one must derive new
list classes that inherit from the base classes described above.  While
this is not difficult, it is cumbersome and time consuming.  Instead of
explicitly declaring these derived classes, the
<CODE>DECLARE_LIST_CLASS</CODE> macro may be used to declare them
automatically.  This macro takes two arguments: the name of the new list
class and the type for the data in the list elements.  It then creates
classes derived from <CODE>glist</CODE>, <CODE>glist_e</CODE>, and <CODE>glist_iter</CODE>
that use the specified type for the element data <A NAME="DOCF6" HREF="suif1_foot.html#FOOT6">(6)</A>.
For example, <CODE>DECLARE_LIST_CLASS(string_list, char*)</CODE> generates
classes named <CODE>string_list</CODE>, <CODE>string_list_e</CODE>, and
<CODE>string_list_iter</CODE>.  The <CODE>string_list_e</CODE> class includes a
<CODE>contents</CODE> field with type <CODE>char*</CODE>.  The methods in all of
these classes are changed to use the <CODE>char*</CODE> type where appropriate
and some new methods are added.  (Once the element data type is known,
it is possible to provide methods, such as <CODE>copy</CODE>, that must access
the data fields.)

</P>
<P>
The <CODE>DECLARE_LIST_CLASS</CODE> macro is implemented by other macros, one
for each kind of class.  Using these other macros directly gives you
more control over the names of the new classes and allows you to add
more methods in the derived classes.  There are several examples of this
in the library code.  Another advanced feature of the
<CODE>DECLARE_LIST_CLASS</CODE> macro is the virtual <CODE>set_elem</CODE> method
which is included in the generated list class.  This method is called
for every element that is added to a list.  The base <CODE>set_elem</CODE>
method does nothing, but a derived class can change this method to
automatically update information in list elements when they are
added to a list.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_91.html">previous</A>, <A HREF="suif1_93.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
